<script lang="ts" setup>
import { nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import type { Member } from "@/types/Member";
import http from '@/services/http'
import { useLoadingStore } from '@/stores/loading';
import memberService from '@/services/member'
import { useMemberStore } from '@/stores/member';

const memberStore = useMemberStore()
const headers = [
  {
    title: 'Id',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Tel',
    key: 'tel',
    value: 'tel'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]
const loadingStore = useLoadingStore()
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const initilMember: Member = {
  id: -1,
  name: '',
  tel: '0123456789'
}
const editedMember = ref<Member>(JSON.parse(JSON.stringify(initilMember)))

let editedIndex = -1
let lastId = 4
function onSubmit() {}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedMember.value = Object.assign({}, initilMember)
  })
}
async function deleteItemConfirm() {
  // Delete item from list
  closeDelete()
  await memberStore.deleteMember(editedMember.value) 
}
function editItem(item: Member) {
  editedMember.value = Object.assign({}, item)
  dialog.value = true
}
function deleteItem(item: Member) {
  editedMember.value = Object.assign({}, item)
  dialogDelete.value = true
  editedIndex = -1
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    editedMember.value = Object.assign({}, initilMember)
    editedIndex = -1
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return

  closeDialog()
  await memberStore.saveMember(editedMember.value)
}

// Data function


onMounted(() => {
  memberStore.getMembers()
})
</script>
<template>
  <div>
    <v-data-table :headers="headers" :items="memberStore.members">
      <template v-slot:top>
        <v-toolbar flat>
          <v-toolbar-title>Members</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <!-- Put Edited Dialog -->

          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn color="primary" v-bind="props"> New Member </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Member Profile</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="editedMember.name"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Name"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="editedMember.tel"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Tel"
                        ></v-text-field>
                      </v-col>
                      
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <!-- Delete Dialog-->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5"
                >Are you sure you want to delete this item?</v-card-title
              >
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
        <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
      <template v-slot:no-data>
        <v-btn color="primary" @click="memberStore.getMembers"> Reset </v-btn>
      </template>
    </v-data-table>
  </div>
</template>
